// ==============================================================
// File generated by Xilinx Model Composer(TM)
// Version: 2020.2
//  
// (c) Copyright 2017 - 2020 Xilinx, Inc. All rights reserved.
//  
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
//  
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
//  
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
//  
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES.
// ==============================================================
#include "XMC_CurrentControl.h"
#include <ap_shift_reg.h>
#include <xmcArithBasics.h>
#include <xmcArithDivide.h>
#include <xmcArithSatBasics.h>
#include <StreamAdapters.h>
void
XMC_CurrentControl_core(float Il_ref, float Kp, float Ki, int16_t Il_raw, 
    int16_t Vin_raw, int16_t Vout_raw, uint32_t Ts, uint16_t CLOCK_period, 
    uint16_t* duty_cycle_ticks)
{
    #pragma HLS inline
    uint16_t Data_Type_Conversion_out1;
    float Data_Type_Conversion2_out1;
    float Data_Type_Conversion3_out1;
    float Data_Type_Conversion4_out1;
    float Data_Type_Conversion5_out1;
    float Data_Type_Conversion6_out1;
    float Data_Type_Conversion7_out1;
    float Data_Type_Conversion9_out1;
    float Delay_out1;
    float Gain3_out1;
    float Gain2_out1;
    float Gain_out1;
    float Gain1_out1;
    float MAX_out1;
    uint32_t Reinterpret1_out1;
    float MIN_out1;
    float Constant_out1;
    float Product3_out1;
    float Subtract_out1;
    ap_ufixed<1,1,AP_TRN,AP_WRAP,0> Bit_Slice1_out1;
    float Product1_out1;
    float Product2_out1;
    uint32_t Reinterpret_out1;
    float Sum1_out1;
    ap_ufixed<1,1,AP_TRN,AP_WRAP,0> Bit_Slice_out1;
    float Sum_out1;
    bool Equals_out1;
    float Divide_out1;
    bool Greater_out1;
    bool Conditional_cmp_out;
    float Conditional_out1;
    bool Lesser_out1;
    bool Bitwise_OR_out1;
    bool Conditional1_cmp_out;
    bool Unit_Delay_out1;
    float Conditional1_out1;
    bool Bitwise_AND2_out1;
    ap_fixed<17,1,AP_TRN,AP_WRAP,0> Data_Type_Conversion8_out1;
    bool Conditional_cmp_out_0;
    ap_fixed<33,17,AP_TRN,AP_WRAP,0> Product_out1;
    float Conditional_out1_0;
    float Sum2_out1;
    float MAX_c = 1.000000000e+00f;
    float MIN_c = 0.000000000e+00f;
    bool Conditional_thr_out = false;
    float Constant_c = 0.000000000e+00f;
    bool Conditional_thr_out_0 = false;
    bool Conditional1_thr_out = false;
    static ap_shift_reg<float, 1> Delay_q;
    #pragma HLS reset variable=Delay_q
    Data_Type_Conversion_out1 = xmc::arith::convert< uint16_t >(CLOCK_period);
    Data_Type_Conversion2_out1 = xmc::arith::convert< float >(Vin_raw);
    Data_Type_Conversion3_out1 = xmc::arith::convert< float >(Vout_raw);
    Data_Type_Conversion4_out1 = xmc::arith::convert< float >(Ts);
    Data_Type_Conversion5_out1 = xmc::arith::convert< float >(Ki);
    Data_Type_Conversion6_out1 = xmc::arith::convert< float >(Kp);
    Data_Type_Conversion7_out1 = xmc::arith::convert< float >(Il_ref);
    Data_Type_Conversion9_out1 = xmc::arith::convert< float >(Il_raw);
    static uint32_t Delay_init_count_down = 1u;
    #pragma HLS reset variable=Delay_init_count_down
    float Delay_tmp(0);
    if (!Delay_init_count_down) {
        Delay_tmp = Delay_q.read();
    }
    Delay_out1 = Delay_tmp;
    if (Delay_init_count_down) {
        --Delay_init_count_down;
    }
    float Gain3_const = 1.528936811e-02f;
    xmc::arith::convert(Gain3_out1, xmc::arith::mul< float >(
        Data_Type_Conversion2_out1, Gain3_const));
    float Gain2_const = 1.528936811e-02f;
    xmc::arith::convert(Gain2_out1, xmc::arith::mul< float >(
        Data_Type_Conversion3_out1, Gain2_const));
    float Gain_const = 9.999999717e-10f;
    xmc::arith::convert(Gain_out1, xmc::arith::mul< float >(
        Data_Type_Conversion4_out1, Gain_const));
    float Gain1_const = 1.525878906e-03f;
    xmc::arith::convert(Gain1_out1, xmc::arith::mul< float >(
        Data_Type_Conversion9_out1, Gain1_const));
    MAX_out1 = MAX_c;
    Reinterpret1_out1 = *reinterpret_cast< uint32_t* >(&Delay_out1);
    MIN_out1 = MIN_c;
    Constant_out1 = Constant_c;
    xmc::arith::mul(Product3_out1, Data_Type_Conversion5_out1, Gain_out1);
    xmc::arith::sub(Subtract_out1, Data_Type_Conversion7_out1, Gain1_out1);
    ap_ufixed<32,32,AP_TRN,AP_WRAP,0> Bit_Slice1_out_temp;
    Bit_Slice1_out_temp = Reinterpret1_out1;
    Bit_Slice1_out1 = Bit_Slice1_out_temp.range(31, 31);
    xmc::arith::mul(Product1_out1, Subtract_out1, Data_Type_Conversion6_out1);
    xmc::arith::mul(Product2_out1, Subtract_out1, Product3_out1);
    Reinterpret_out1 = *reinterpret_cast< uint32_t* >(&Subtract_out1);
    xmc::arith::add(Sum1_out1, Product1_out1, Delay_out1);
    ap_ufixed<32,32,AP_TRN,AP_WRAP,0> Bit_Slice_out_temp;
    Bit_Slice_out_temp = Reinterpret_out1;
    Bit_Slice_out1 = Bit_Slice_out_temp.range(31, 31);
    xmc::arith::add(Sum_out1, Sum1_out1, Gain2_out1);
    Equals_out1 = Bit_Slice_out1 == Bit_Slice1_out1;
    xmc::arith::div(Divide_out1, Sum_out1, Gain3_out1);
    Greater_out1 = Divide_out1 > MAX_out1;
    Conditional_cmp_out = Greater_out1 != Conditional_thr_out_0;
    Conditional_out1 = Conditional_cmp_out ? MAX_out1 : Divide_out1;
    Lesser_out1 = Conditional_out1 < MIN_out1;
    Bitwise_OR_out1 = Greater_out1 | Lesser_out1;
    Conditional1_cmp_out = Lesser_out1 != Conditional1_thr_out;
    static bool Unit_Delay_q = false;
    #pragma HLS reset variable=Unit_Delay_q
    Unit_Delay_out1 = Unit_Delay_q;
    Unit_Delay_q = Bitwise_OR_out1;
    Conditional1_out1 = Conditional1_cmp_out ? MIN_out1 : Conditional_out1;
    Bitwise_AND2_out1 = Unit_Delay_out1 & Equals_out1;
    Data_Type_Conversion8_out1 = 
        xmc::arith::convert< ap_fixed<17,1,AP_TRN,AP_WRAP,0> >(
        xmc::arith::convert< ap_fixed<17,1,AP_TRN,AP_SAT,0> >(Conditional1_out1
        ));
    Conditional_cmp_out_0 = Bitwise_AND2_out1 != Conditional_thr_out;
    xmc::arith::mul(Product_out1, Data_Type_Conversion8_out1, 
        Data_Type_Conversion_out1);
    Conditional_out1_0 = Conditional_cmp_out_0 ? Constant_out1 : Product2_out1;
    *duty_cycle_ticks = xmc::arith::satConvert< uint16_t >(Product_out1);
    xmc::arith::add(Sum2_out1, Conditional_out1_0, Delay_out1);
    Delay_q.shift(Sum2_out1, 0);
}

/**
 * @brief XMC_CurrentControl
 * @param Il_ref direction=input protocol=AXI4-Stream length=1
 * @param Kp direction=input protocol=AXI4-Stream length=1
 * @param Ki direction=input protocol=AXI4-Stream length=1
 * @param Il_raw direction=input protocol=AXI4-Stream length=1
 * @param Vin_raw direction=input protocol=AXI4-Stream length=1
 * @param Vout_raw direction=input protocol=AXI4-Stream length=1
 * @param Ts direction=input protocol=AXI4-Stream length=1
 * @param CLOCK_period direction=input protocol=No protocol
 * @param duty_cycle_ticks direction=output protocol=Valid port
 */
void
XMC_CurrentControl(hls::stream< float >& Il_ref, hls::stream< float >& Kp, 
    hls::stream< float >& Ki, hls::stream< int16_t >& Il_raw, 
    hls::stream< int16_t >& Vin_raw, hls::stream< int16_t >& Vout_raw, 
    hls::stream< uint32_t >& Ts, uint16_t CLOCK_period, uint16_t* 
    duty_cycle_ticks)
{
    #pragma HLS INTERFACE axis port=Il_ref
    #pragma HLS INTERFACE axis port=Kp
    #pragma HLS INTERFACE axis port=Ki
    #pragma HLS INTERFACE axis port=Il_raw
    #pragma HLS INTERFACE axis port=Vin_raw
    #pragma HLS INTERFACE axis port=Vout_raw
    #pragma HLS INTERFACE axis port=Ts
    #pragma HLS INTERFACE ap_none port=CLOCK_period
    #pragma HLS INTERFACE ap_vld port=duty_cycle_ticks
    #pragma HLS INTERFACE ap_ctrl_none port=return

    float Il_ref_adapter_out1;
    float Kp_adapter_out1;
    float Ki_adapter_out1;
    int16_t Il_raw_adapter_out1;
    int16_t Vin_raw_adapter_out1;
    int16_t Vout_raw_adapter_out1;
    uint32_t Ts_adapter_out1;
    xmc::StreamAdapter::readStream(Il_ref, &Il_ref_adapter_out1);
    xmc::StreamAdapter::readStream(Kp, &Kp_adapter_out1);
    xmc::StreamAdapter::readStream(Ki, &Ki_adapter_out1);
    xmc::StreamAdapter::readStream(Il_raw, &Il_raw_adapter_out1);
    xmc::StreamAdapter::readStream(Vin_raw, &Vin_raw_adapter_out1);
    xmc::StreamAdapter::readStream(Vout_raw, &Vout_raw_adapter_out1);
    xmc::StreamAdapter::readStream(Ts, &Ts_adapter_out1);
    XMC_CurrentControl_core(Il_ref_adapter_out1, Kp_adapter_out1, 
        Ki_adapter_out1, Il_raw_adapter_out1, Vin_raw_adapter_out1, 
        Vout_raw_adapter_out1, Ts_adapter_out1, CLOCK_period, duty_cycle_ticks)
        ;
}


