% This file computes the values of kp and ki for the current regulator.
% Place this file in the same folder as the Simulink file.

% PARAMETERS

fs = 20e3;
Ts = 1/fs;
phase = 0.5;       
SAMPLEPERIOD = [Ts Ts*phase];

Lb = 2.5e-3; % Inductance used for the boost [H]
Rb = 22e-3;  % Resistance of the inductor used for the boost [Ohm]
C = 260e-6;  % Capacitance of the DC bus [F]
Vb = 100     % Battery voltage [V]
Rload = 5;   % Load resistance [Ohm]

Iref = 3;

% BOOST CURRENT REGULATOR

K1 = 1/Rb;
T1 = Lb/Rb;

% 1/2Ts of sampling, 1/2Ts of computation, 1/3 for the triangle carrier
Td = (1/2 + 1/2 + 1/3)*Ts; 

Tn1 = T1;
Ti1 = 2*K1*Td;

kp = Tn1/Ti1;
ki = 1/Ti1;
